//---------------------------------------------------------------------------

#ifndef ClockH
#define ClockH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <math.h>

enum Groesse { gSmall, gMiddle, gBig };
enum PointerStyle { pSLine, pSArrow };
//---------------------------------------------------------------------------
class PACKAGE TClock : public TCustomControl
{
private:
  Graphics::TBitmap *bitmap;
  void ZeichneZiffern( TCanvas &canvas );
  void ZeichneAlleZeiger( TCanvas &canvas );
  void ZeichneZeiger( TCanvas &canvas, int nLineWidth, int nWertWinkel,
                        int nLaengeZeiger, int nPointerPos,int nPointWidth, bool bPointerArt );
  int nRadiusUhr;
  double InRad( int Grad ){ return ((Grad * M_PI) / 180);}
  int nPosMitte;
  int nPunktRadius;
  int nFontSize;
  int nZeigerFaktor;    // Faktor Zeigerbreite
  int nRand;            // Rand vom Bitmap
  int nGroesse;         // Uhrgroesse
  Groesse FMySize;      // Uhr Enum
  PointerStyle FMyPointerArt;   // Aussehen der Zeiger
  void __fastcall SetClockSize( Groesse gWert );
  Groesse __fastcall GetClockSize(void) { return FMySize; };
  void __fastcall SetPointerArt( PointerStyle pSWert );
  PointerStyle __fastcall GetPointerArt(void) { return FMyPointerArt; };
  void __fastcall SetBkColor( TColor clBackround );
  TColor __fastcall GetBkColor(void) { return clBkUhrColor; };
  void __fastcall SetPointerColor( TColor clPColor );
  TColor __fastcall GetPointerColor(void) { return clPointerColor; };
  int __fastcall GetCompoWidth(void);
  int __fastcall GetCompoHeight(void);
  int nCompoSize;       // Kompomentengroesse
  int nXPosSec;
  int nYPosSec;
  int nXPosHour;
  int nYPosHour;
  int nXPosMin;
  int nYPosMin;
  int nLaengeSecZeiger;
  int nLaengeMinZeiger;
  int nLaengeStdZeiger;
  TColor clBkUhrColor;    // Farbe Ziffernblatt
  TColor clPointerColor;  // Farbe der Zeiger
  TRect bmpRect;
  TTimer* Timer;
protected:
  virtual void __fastcall Paint();
  virtual void __fastcall OnTimer( TObject* Sender );
  void DefineSize( void );      // Initialisiert die Uhr
public:
  __fastcall TClock(TComponent* Owner);
  virtual __fastcall ~TClock();
__published:
  // Eigenschaften der Komponente
  __property Groesse Size = { read=GetClockSize, write=SetClockSize };
  __property PointerStyle PointerArt = { read=GetPointerArt, write=SetPointerArt };
  __property TColor BkColor = { read=GetBkColor, write=SetBkColor };
  __property TColor PointerColor = { read=GetPointerColor, write=SetPointerColor };
  __property Width = { read=GetCompoWidth };
  __property Height = { read=GetCompoHeight };
  __property OnMouseDown;
  __property OnMouseMove;
  __property OnMouseWheel;
  __property OnKeyDown;
};
//---------------------------------------------------------------------------
#endif
